% [Fq Det nmin] = DabetFx2Fq(Dab, Fx)
% Calcul pour la situation Dab de
% Fq : forces qui quilibrent Fx avec la composante
% minimale  FqMin : Renvoi Fq = [], si impossible
% Det : dterminant de P'*P
% nmin : composante minimale du noyau dans la direction ppale
function [Fq, Det, nmin] = DabetFx2Fq(Dab,Fx)
global FqMin Nq
Fq = [] ;
[Q P] = Dab2QetP(Dab) ;
A = P'; AAt = A*P ;
Det = det(AAt) ;
Noy = null(A) ; 
if max(Noy) < 0, Noy = -Noy; end ;
nmin = min(Noy) ;
if Det < eps | nmin <= 0, return ; end
iP = -P*inv(AAt);
Fq = iP*Fx;
% [fNeg i] = min(Fq);
% coef = (FqMin - fNeg )/Noy(i) ;
coef = max((FqMin-Fq)./Noy) ;
Fq = Fq + coef*Noy;
return
