% [Carol] = Mat2Carol(MatRot, Carol)
% 
% Extraction des angles de Cap, assiette et Roulis (ordre ZYX)
% de la matrice MatRot
% Pour abs(assiette) > pi/2 - 1.E-5   conservation de la somme 
% ou de la diffrence des valeurs passes en rfrence, qui
% sont galement utilises pour envoyer la solution dans la mme
% nappe.
%
function [Carol] = Mat2Carol(a,Carol)

tet = -asin(a(3,1));
if abs(tet) < pi/2-1.e-7
   psi = atan2(a(2,1),a(1,1));
   phi = atan2(a(3,2),a(3,3));
else
   if tet > 0.
      som = Carol(1)+Carol(3);
      dif = atan2(-a(1,2),a(2,2));
   else
      dif = Carol(1)-Carol(3);
      som = atan2(-a(1,2),a(2,2));
   end
   psi = (som+dif)/2.;
   phi = (som-dif)/2.;
end
% On met dans la mme nappe que la solution prcdente
if abs(Carol(2)) > pi/2
   if psi < 0., psi = psi+pi; else psi = psi-pi; end
   if phi < 0., phi = phi+pi; else phi = phi-pi; end
   if tet > 0., tet = pi-tet; else tet =-pi-tet; end
end
Carol(1)=psi;
Carol(2)=tet;
Carol(3)=phi;
return
    


