% [Dab iter] = Qmes2Dab(Qmes, itermax, Dab_ini) : Rsolution itrative de Q=H(Dab)
%
% Le nombre d'itration est limit  itermax. Si ce nombre
% est atteint, Dab = [] est renvoy.
% La plus grande variation de Qi est limite  dQsat,
% Il y a convergence quand max(|Qmesi-Qi|) < MyEps. Le rsultat est
% renvoy avec iter > 0
% Dans le cas contraire, il y a arrt si l'erreur augmente. La valeur
% iter renvoye est ngative (iter < 0)
% Si on atteint le nombre max d'itrations, on renvoi iter = 0
% 
% MyEps est galement utilis comme limite d'approximation
% pour ngliger (1-cos(MyEps)).
%
% Le systme tant sur-dtermin, on pourra examiner au retour
% l'cart entre Q = H(Dab) et Qmes.
%
function [Dab, iter] = Qmes2Dab(Qmes, itermax, Dab_ini)
global Nq dLsat dAsat MyEps
% Initialisation de la situation
Cab = Dab_ini(1:3,1:3);
AB = Dab_ini(1:3,4) ;
dQold = inf ;
I3 = eye(3) ;
for iter = 1:itermax
   % Calcul longueurs et matrice cinmatique
   Dab = [Cab AB; 0 0 0 1];
   [Q P] = Dab2QetP(Dab) ;
   % Calcul erreur par rapport aux longueurs mesures
   dQ = Qmes - Q ;
   dQmoy = norm(dQ)/Nq ;
   % Examen si convergence 
   if dQmoy  < MyEps, return; end
   % Arrt si divergence
   if dQmoy > dQold, 
      iter = -iter; return; 
   end; 
   dQold = dQmoy ;
   % Erreur de situation correspondante 
   dW = (P'*P)\(P'*dQ) ;
   dW = inv(P'*P)*(P'*dQ) ;
   % Extraction erreur de translation et rotation
   dM = dW(1:3,1);
   dA = dW(4:6,1);
   % On sature les erreurs  dLsat et dAsat
   dMmax = max(abs(dM)); coef = dMmax/dLsat ;
   if coef > 1., dM = dM/coef ; end   
   dAmax = max(abs(dA)); coef = dAmax/dAsat ;
   if coef > 1., dA = dA/coef ; end   
   % Correction position
   AB = AB + dM;
   Anti = manti(dA);
   % Carr du sinus angle cart orientation
   s2 = dA'*dA ;
   R = I3 + Anti + ((1-sqrt(1-s2))/s2)*Anti*Anti ;
   Cab = R*Cab ;
end
iter = 0
return
   
   
   
